/*
 *  $Id: comm_rsize.c,v 1.3 1994/06/07 21:24:28 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/***********************************************************************
*                                                                      *
*   comm_rs.c                                                          *
*   MPI for MS-Windows 3.1                                             *
*   current version: 0.99b          06/10/95                           *
*                                                                      *
*   Joerg Meyer                                                        *
*   University of Nebraska at Omaha (UNO)                              *
*   Department of Computer Science                                     *
*                                                                      *
*   This is an MPI implementation for MS-Windows 3.1                   *
*   It is based on the MPI implementation from Argonne National        *
*   Laboratory and Mississippi State University, version from          *
*   June 17, 1994. Note their COPYRIGHT.                               *
*   ( source code and user's guide available by anonymous FTP from     *
*     info.mcs.anl.gov in directory /pub/mpi )                         *
*   Anyone is free to copy and modify this code to suit his or her     *
*   own purposes as long as these notices are retained.                *
*                                                                      *
***********************************************************************/

#include <mpiimpl.h>
#include <mpisys.h>
#pragma hdrstop

/*@

MPI_Comm_remote_size - Determines the size of the remote group 
                       associated with an inter-communictor

Input Parameter:
. comm - communicator (handle) 

Output Parameter:
. size - number of processes in the group of comm  (integer) 

@*/
Int MPI_Comm_remote_size ( MPI_Comm  comm, Int far *size)
{
    Int errno;
    if (MPIR_TEST_COMM(comm,comm) || MPIR_TEST_ARG(size)) 
    {
	if (size) 
	    (*size) = MPI_UNDEFINED;
	return MPIR_ERROR( MPI_COMM_WORLD, errno, 
		      "Error in MPI_COMM_REMOTE_SIZE" );
    }
    else 
	(*size) = comm->group->np;

  return (MPI_SUCCESS);
}
